// transmitter_v2.pde
//
// Überwacht die Drehscheibe im Stromzähler mit einer Reflex-Lichtschranke
// und berechnet die Wattzahl
// Der Wert wird dann per Funk an einen Empfänger übermittelt
//
// (c) Dirk Melchers
// www.dirk-melchers.de

#include <VirtualWire.h>

int schwellwert_in = 60;
int schwellwert_out = 45;
int insend = 1;
unsigned long last_pulse;
unsigned long time;

long watt = -1;


void setup()
{
  Serial.begin(9600);	  // Debugging only
  Serial.println("setup");

  // Initialise the IO and ISR
  vw_set_ptt_inverted(true); // Required for DR3100
  vw_setup(2000);	 // Bits per sec
}


void loop()
{
  uint8_t buf[100];
  int a;
  int b;

  a = analogRead(0);
  b = map(a,0,1024,0,256);

  if(b >= schwellwert_in && !insend) {   
    digitalWrite(13, true); // Flash a light to show transmitting

    time = millis();

    if (last_pulse > 0 && last_pulse < time) {
      watt = int((1000.00/75.00)*3600/((time - last_pulse)/1000));
    }
    last_pulse = time;

    // Send the "Watt" to the receiver
    if(watt > 0) {
      sprintf((char *)buf,"%d",watt);
      vw_send((uint8_t *)buf, strlen((char *)buf)+1);
      vw_wait_tx(); // Wait until the whole message is gone
    }

    insend = 1;
  }


  if(b < schwellwert_out && insend) {
    insend = 0;
    digitalWrite(13, false);
  }

  delay(10);
}






